package Compiladores;

import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.UIManager;

import java.awt.Color;

import javax.swing.JTextField;
import javax.swing.JButton;

import java.awt.Font;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JLabel;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.nio.file.Path;
import java.nio.file.Paths;

import javax.swing.ImageIcon;

import java.awt.Toolkit;

/**
 * Clase que gestiona el proceso y tiene la interfaz grfica
 * @author  Enrique Marquet Durn
 * @version 1.0
 */
public class VentDatos {

	private JFrame frmPfccompiladores;
	private JTextField pathOpDoc;
	String nombreFicheroEntrada = "";
	String nombreDocXMLEntrada = "";
	private JTextField pathDirSal;
	String nombreDirSalida = "";
	int crearFicheroSalida = 0;
	private JButton btnDirGra;
	private JTextField pathOpRef;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					VentDatos window = new VentDatos();
					window.frmPfccompiladores.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public VentDatos() {
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		frmPfccompiladores = new JFrame();
		frmPfccompiladores.setIconImage(Toolkit.getDefaultToolkit().getImage(VentDatos.class.getResource("/images/script.gif")));
		frmPfccompiladores.setResizable(false);
		frmPfccompiladores.setFont(new Font("Dialog", Font.BOLD, 12));
		frmPfccompiladores.setTitle("PFC-Compiladores");
		frmPfccompiladores.setBounds(100, 100, 737, 456);
		frmPfccompiladores.setLocationRelativeTo(null);
		frmPfccompiladores.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frmPfccompiladores.getContentPane().setLayout(null);
		JPanel panelEnt = new JPanel();
		panelEnt.setBorder( new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Datos de Entrada", TitledBorder.LEADING, TitledBorder.TOP, null, new Color(0, 0, 255)));
		panelEnt.setToolTipText("");
		panelEnt.setBounds(10, 11, 686, 156);
		frmPfccompiladores.getContentPane().add(panelEnt);
		panelEnt.setLayout(null);
		
		pathOpDoc = new JTextField();
		pathOpDoc.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				nombreFicheroEntrada = e.getActionCommand();
				Path inputPath = Paths.get(nombreFicheroEntrada);
				nombreFicheroEntrada = inputPath.toAbsolutePath().toString();
				File fileopen = new File (nombreFicheroEntrada);
				pathOpDoc.setText(nombreFicheroEntrada);
				try {
					
//					if (!fileopen.isFile() || !isReadable(nombreFicheroEntrada)){
					if (!fileopen.isFile()){
						JOptionPane.showMessageDialog(frmPfccompiladores, "Fichero no existe", "Error Fichero", JOptionPane.ERROR_MESSAGE);
						return;
					}
					
					if (!nombreFicheroEntrada.endsWith(".odt")){
						JOptionPane.showMessageDialog(frmPfccompiladores, "La extensin del fichero debe ser .odt", "Error Fichero", JOptionPane.ERROR_MESSAGE);
						return;
					}
				}
				catch (Exception exc){
					JOptionPane.showMessageDialog(frmPfccompiladores, "Error en Fichero entrada");
				}

			}
		});
		pathOpDoc.setToolTipText("Documento de texto OpenDocument a procesar.");
		pathOpDoc.setBounds(12, 102, 495, 20);
		panelEnt.add(pathOpDoc);
		pathOpDoc.setColumns(10);
		
		JButton btnBusqueda = new JButton("B\u00FAsqueda");
		btnBusqueda.setIcon(new ImageIcon(VentDatos.class.getResource("/images/folder.gif")));
		btnBusqueda.setToolTipText("Buscar documento a procesar.");
		btnBusqueda.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser fileopen = new JFileChooser(System.getProperty("user.dir"));
				fileopen.setApproveButtonText("Seleccionar");
				fileopen.setDialogTitle("Seleccin fichero ODF");
				fileopen.setFileFilter(new FileNameExtensionFilter("Documentos de texto ODF (.odt)    (*.odt)" ,"odt"));
//				int ret = fileopen.showDialog(frmPfccompiladores, "Seleccionar fichero");
				int ret = fileopen.showOpenDialog(frmPfccompiladores);
				if (ret == JFileChooser.APPROVE_OPTION) {
				      File file = fileopen.getSelectedFile();
				      nombreFicheroEntrada = file.getAbsolutePath();
				      pathOpDoc.setText(nombreFicheroEntrada);
				}

			}
		});
		btnBusqueda.setBounds(519, 95, 127, 34);
		panelEnt.add(btnBusqueda);
		
		JLabel lblNewLabel = new JLabel("Documento de texto OpenDocument");
		lblNewLabel.setFont(new Font("Tahoma", Font.BOLD, 13));
		lblNewLabel.setLabelFor(pathOpDoc);
		lblNewLabel.setBounds(12, 82, 252, 16);
		panelEnt.add(lblNewLabel);
		
		JLabel lblDocumentoConLas = new JLabel("Documento con la configuraci\u00F3n");
		lblDocumentoConLas.setFont(new Font("Tahoma", Font.BOLD, 13));
		lblDocumentoConLas.setBounds(12, 23, 252, 16);
		panelEnt.add(lblDocumentoConLas);
		
		pathOpRef = new JTextField();
		pathOpRef.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				nombreDocXMLEntrada = e.getActionCommand();
				Path inputPath = Paths.get(nombreDocXMLEntrada);
				nombreDocXMLEntrada = inputPath.toAbsolutePath().toString();
				File fileopen = new File (nombreDocXMLEntrada);
				pathOpRef.setText(nombreDocXMLEntrada);
				try {
					if (!fileopen.isFile()){
						JOptionPane.showMessageDialog(frmPfccompiladores, "Documento XML no existe", "Error Fichero XML", JOptionPane.ERROR_MESSAGE);
						return;
					}
					
					if (!nombreFicheroEntrada.endsWith(".xml")){
						JOptionPane.showMessageDialog(frmPfccompiladores, "La extensin del documento debe ser .xml", "Error Fichero XML", JOptionPane.ERROR_MESSAGE);
						return;
					}
				}
				catch (Exception exc) {
					JOptionPane.showMessageDialog(frmPfccompiladores, "Error en Domento XML de entrada");
				}

			}
		});
		pathOpRef.setToolTipText("Documento de configuraci\u00F3n del proceso.");
		pathOpRef.setColumns(10);
		pathOpRef.setBounds(12, 43, 495, 20);
		panelEnt.add(pathOpRef);
		
		JButton btnDocRef = new JButton("B\u00FAsqueda");
		btnDocRef.setIcon(new ImageIcon(VentDatos.class.getResource("/images/folder.gif")));
		btnDocRef.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JFileChooser fileopen = new JFileChooser(System.getProperty("user.dir"));
				fileopen.setApproveButtonText("Seleccionar");
				fileopen.setDialogTitle("Seleccin fichero XML");
				fileopen.setFileFilter(new FileNameExtensionFilter("Documentos XML (.xml)      (*.xml)" ,"xml"));
				int ret = fileopen.showOpenDialog(frmPfccompiladores);
				if (ret == JFileChooser.APPROVE_OPTION) {
				      File file = fileopen.getSelectedFile();
				      nombreDocXMLEntrada = file.getAbsolutePath();
				      pathOpRef.setText(nombreDocXMLEntrada);
				}
			}
		});
		btnDocRef.setToolTipText("Buscar documento de configuraci\u00F3n.");
		btnDocRef.setBounds(519, 36, 127, 34);
		panelEnt.add(btnDocRef);
		
		JPanel panelSal = new JPanel();
		panelSal.setBorder(new TitledBorder(UIManager.getBorder("TitledBorder.border"), "Datos de Salida", TitledBorder.LEADING, TitledBorder.TOP, null, Color.BLUE));
		panelSal.setBounds(10, 179, 686, 156);
		frmPfccompiladores.getContentPane().add(panelSal);
		panelSal.setLayout(null);
		
		pathDirSal = new JTextField();
		pathDirSal.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				nombreDirSalida = e.getActionCommand();
				Path inputPath = Paths.get(nombreDirSalida);
				nombreDirSalida = inputPath.toAbsolutePath().toString();
				File fileopen = new File (nombreDirSalida);
				pathDirSal.setText(nombreDirSalida);
				try {
					if(!fileopen.isDirectory() && fileopen.exists()) {
						JOptionPane.showMessageDialog(frmPfccompiladores, "No se trata de un  directorio!", "Error Directorio", JOptionPane.ERROR_MESSAGE);
						return;
					}
					if(!fileopen.exists()) {
						int res = JOptionPane.showConfirmDialog(pathDirSal, "Desea crear el directorio?", "Directorio No Existe!!", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
						if (res == JOptionPane.YES_OPTION)
							crearFicheroSalida = 1;
						else {
							crearFicheroSalida = 0;
							return;
						}
					}
				}
				catch (Exception exc){
					JOptionPane.showMessageDialog(frmPfccompiladores, "Error en Directorio Salida");
				}

			}
		});
		pathDirSal.setToolTipText("Directorio donde se grabar\u00E1n los archivos de audio.");
		pathDirSal.setBounds(10, 44, 495, 20);
		panelSal.add(pathDirSal);
		pathDirSal.setColumns(10);
		
		JLabel lblNewLabel_1 = new JLabel("Directorio para grabar los archivos de audio");
		lblNewLabel_1.setFont(new Font("Tahoma", Font.BOLD, 13));
		lblNewLabel_1.setLabelFor(pathDirSal);
		lblNewLabel_1.setBounds(10, 25, 356, 16);
		panelSal.add(lblNewLabel_1);
		
		btnDirGra = new JButton("B\u00FAsqueda");
		btnDirGra.setIcon(new ImageIcon(VentDatos.class.getResource("/images/folder.gif")));
		btnDirGra.setToolTipText("Buscar directorio donde se guardar\u00E1n los archivos de audio generados.");
		btnDirGra.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				JFileChooser fileopen = new JFileChooser(System.getProperty("user.dir"));
				fileopen.setApproveButtonText("Seleccionar");
				fileopen.setDialogTitle("Seleccin directorio salida");
				fileopen.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				int ret = fileopen.showOpenDialog(frmPfccompiladores);
				if (ret == JFileChooser.APPROVE_OPTION) {
				      File file = fileopen.getSelectedFile();
				      nombreDirSalida = file.getAbsolutePath();
				      pathDirSal.setText(nombreDirSalida);
				    }

			}
		});
		btnDirGra.setBounds(517, 37, 127, 34);
		panelSal.add(btnDirGra);
		
		JButton btnProcesar = new JButton("Procesar");
		btnProcesar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// Antes del inicio del proceso hay que comprobar que todos los campos solicitados son correctos
				// en el caso de producirse algn error hay que comunicarlo al usuario y detener el proceso para que vuelva
				// a completar los datos. La manera de avisar al usuario es por medio de ventanas con el correspondiente error.
				// Si todo es correcto se inicia todo el proceso y se mantiene a la espera de la finalizacin para cerrar la
				// ventana principal y dar por concludo el programa.
				
				// Obtencin ruta y fichero de entrada a procesar
				try {
					nombreFicheroEntrada = pathOpDoc.getText();
				} catch (java.lang.NullPointerException er){
					JOptionPane.showMessageDialog(frmPfccompiladores, "Campo Documento de Texto OpenDocument erroneo.", "Error Fichero", JOptionPane.ERROR_MESSAGE);
				
				}
				// Si se ha dejado sin rellenar daremos error y se vuelven a pedir los datos
				if (nombreFicheroEntrada.equals("") || nombreFicheroEntrada.trim().isEmpty()) {
					JOptionPane.showMessageDialog(frmPfccompiladores, "Fichero a procesar debe informarse.", "Error Fichero", JOptionPane.ERROR_MESSAGE);
					return;
				}
				Path inputPath = Paths.get(nombreFicheroEntrada);
				nombreFicheroEntrada = inputPath.toAbsolutePath().toString();
				File fileopen = new File (nombreFicheroEntrada);
				pathOpDoc.setText(nombreFicheroEntrada);
				
				// Obtencin ruta y fichero del documento XML de configuracin
				try {
					nombreDocXMLEntrada = pathOpRef.getText();
				} catch (java.lang.NullPointerException er){
					JOptionPane.showMessageDialog(frmPfccompiladores, "Campo Documento con la configuracin erroneo.", "Error Fichero", JOptionPane.ERROR_MESSAGE);
				
				}
				// Si se ha dejado sin rellenar daremos error y se vuelven a pedir los datos
				if (nombreDocXMLEntrada.equals("") || nombreDocXMLEntrada.trim().isEmpty()) {
					JOptionPane.showMessageDialog(frmPfccompiladores, "Documento con la configuracin del proceso debe informarse.", "Error Fichero", JOptionPane.ERROR_MESSAGE);
					return;
				}
				Path refPath = Paths.get(nombreDocXMLEntrada);
				nombreDocXMLEntrada = refPath.toAbsolutePath().toString();
				File filerefs = new File (nombreDocXMLEntrada);
				pathOpRef.setText(nombreDocXMLEntrada);
				
				// Obtencin de la ruta donde se grabarn los archivos de audio, resultado del proceso
				try {
					nombreDirSalida = pathDirSal.getText();
					// Si se ha dejado sin rellenar daremos error y se vuelven a pedir los datos
					if (nombreDirSalida.equals("") || nombreDirSalida.trim().isEmpty()) {
						JOptionPane.showMessageDialog(frmPfccompiladores, "Directorio para guardar los resultados del proceso debe informarse.", "Error Directorio", JOptionPane.ERROR_MESSAGE);
						return;
					}
				} catch  (java.lang.NullPointerException er) {
					JOptionPane.showMessageDialog(frmPfccompiladores, "Campo directorio para guardar los archivos de audio erroneo.", "Error Directorio", JOptionPane.ERROR_MESSAGE);
				}
				Path outputPath = Paths.get(nombreDirSalida);
				nombreDirSalida = outputPath.toAbsolutePath().toString();
				File fileoutput = new File (nombreDirSalida);
				pathDirSal.setText(nombreDirSalida);
				// Se procede a realizar las comprobaciones sobre los campos obtenidos
				try {
					if (!fileopen.isFile()){
						JOptionPane.showMessageDialog(frmPfccompiladores, "Fichero a procesar no existe", "Error Fichero", JOptionPane.ERROR_MESSAGE);
						return;
					}
					
					if (!nombreFicheroEntrada.endsWith(".odt")){
						JOptionPane.showMessageDialog(frmPfccompiladores, "La extensin del fichero debe ser .odt", "Error Fichero", JOptionPane.ERROR_MESSAGE);
						return;
					}
					
					if (!filerefs.isFile()){
						JOptionPane.showMessageDialog(frmPfccompiladores, "Documento XML a procesar no existe", "Error Fichero", JOptionPane.ERROR_MESSAGE);
						return;
					}
					
					if (!nombreDocXMLEntrada.endsWith(".xml")){
						JOptionPane.showMessageDialog(frmPfccompiladores, "La extensin del documento con la configuracin debe ser .xml", "Error Fichero", JOptionPane.ERROR_MESSAGE);
						return;
					}
					
					if(!fileoutput.isDirectory() && fileoutput.exists()) {
						JOptionPane.showMessageDialog(frmPfccompiladores, "No se trata de un directorio!", "Error Directorio", JOptionPane.ERROR_MESSAGE);
						return;
					}
					if(!fileoutput.exists()) {
						int res = JOptionPane.showConfirmDialog(pathDirSal, "Desea crear el directorio?", "Directorio No Existe!!", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
						if (res == JOptionPane.YES_OPTION)
							crearFicheroSalida = 1;
						else {
							crearFicheroSalida = 0;
							return;
						}
					}
				}
				catch (Exception exc){
					JOptionPane.showMessageDialog(frmPfccompiladores, "Error tratando los ficheros.");
				}
				
				
				// Inicio del proceso
				GestFiles gestfil = new GestFiles();
				// Inicializacin de las rutas de origen y destino, para poder realizar el proceso
				gestfil.initialize(nombreFicheroEntrada, nombreDirSalida);
				gestfil.generarDirs();
				// Creacin de una instancia del analizadador del documento XML contra el DTD de referencia
				// Y comprobacin del contenido del documento de configuracin
				Analyser analiser = new Analyser(nombreDocXMLEntrada);

				int resultadoOK = analiser.informarConfig();
				if (resultadoOK == 1) {
					ventError("Error en el idioma de configuracin");
					return;
				}
				if (resultadoOK == 2) {
					ventError("Error: Valor Imagen no vlido");
					return;
				}
				if (resultadoOK == 3) {
					ventError("Error: Valor Mltiples Archivos no vlido");
					return;
				}
				if (resultadoOK == 4) {
					ventError("Error: Prefijo no informado correctamente");
					return;
				}
				if (resultadoOK == 5) {
					ventError("Error: Valor Tratamiento Notas no vlido");
					return;
				}
				if (resultadoOK != 0) {
					ventError("Errores en el documento de configuracin");
					return;
				}
				if (resultadoOK == 0) {
					int res = JOptionPane.showConfirmDialog(frmPfccompiladores, "Has elegido como idioma de la voz: -- " + analiser.getIdiomaText() + " --\n Quieres Continuar?",
							"Confirmacin Idioma!!", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
					if (!(res == JOptionPane.YES_OPTION)) {
						return;
					}
				}
				
				// Carga del documento odt
				OpenDocument op = new OpenDocument(gestfil.getInputPath().toString());
				op.trtDocumento(analiser, gestfil.getOutputPath().toString(), gestfil.getDirTmp());
				op.close();
				
				JOptionPane.showMessageDialog(frmPfccompiladores, "Finalizacin correcta del proceso!", "Programa terminado", JOptionPane.INFORMATION_MESSAGE);

				// Cierre de la ventana de datos.
				frmPfccompiladores.dispose();
				// Borrar el directorio temporal de trabajo
				gestfil.delete();
			}
		});
		btnProcesar.setBounds(299, 367, 105, 26);
		frmPfccompiladores.getContentPane().add(btnProcesar);
	}
	
	/**
	 * Ventana para visualizar diferentes errores
	 * @param msgError Cadena que contiene el mensaje de error a visualizar
	 */
	private void ventError (String msgError) {
		JOptionPane.showMessageDialog(frmPfccompiladores, msgError);
	}
}
